Public Class Form1

    Dim emp As New Employee("Rod", "Stephens")

    Private Delegate Function NumEmployeesDelegate() As Integer
    Private Sub btnShared_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles btnShared.Click
        Dim show_num As NumEmployeesDelegate
        show_num = AddressOf Employee.GetNumEmployees
        MessageBox.Show(show_num().ToString)
    End Sub

    Private Delegate Function GetNameDelegate() As String
    Private Sub btnInstance_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles btnInstance.Click
        Dim show_name As GetNameDelegate
        show_name = AddressOf emp.ToString
        MessageBox.Show(show_name())
    End Sub
End Class

Public Class Employee
    Implements IDisposable

    Private m_FirstName As String
    Private m_LastName As String

    Private Shared m_NumEmployees As Integer = 0

    Public Shared Function GetNumEmployees() As Integer
        Return m_NumEmployees
    End Function

    Public Sub New(ByVal first_name As String, ByVal last_name As String)
        m_FirstName = first_name
        m_LastName = last_name
        m_NumEmployees += 1
    End Sub

    Public Overrides Function ToString() As String
        Return m_FirstName & " " & m_LastName
    End Function

    Private disposedValue As Boolean = False        ' To detect redundant calls

    ' IDisposable
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' Update m_NumEmployees.
                m_NumEmployees -= 1
            End If
        End If
        Me.disposedValue = True
    End Sub

#Region " IDisposable Support "
    ' This code added by Visual Basic to correctly implement the disposable pattern.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Protected Overrides Sub Finalize()
        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
        Dispose(False)
        MyBase.Finalize()
    End Sub
#End Region

End Class