Option Strict Off

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Test3()
    End Sub

    Private Sub Test1()
        Dim people As New Collection
        people.Add(New Employee("Alice Auxley"))
        people.Add(New Customer("Bob Brentwood"))

        ' Works.
        For Each person As Object In people
            MessageBox.Show(person.Name)
        Next person

        ' Works.
        Dim emp As Employee
        For Each person As Object In people
            If TypeOf person Is Employee Then
                emp = CType(person, Employee)
                MessageBox.Show(emp.Name)
            ElseIf TypeOf person Is Customer Then
                MessageBox.Show(CType(person, Customer).Name)
            End If
        Next person

        ' Works.
        Dim employees As New Collection
        employees.Add(New Employee("Alice Auxley"))
        employees.Add(New Manager("Bob Brentwood"))
        employees.Add(New Employee("Alice Auxley"))
        Dim a_manager As Manager = Nothing
        For Each emp2 As Employee In employees
            If TypeOf emp2 Is Manager Then
                a_manager = CType(emp2, Manager)
                Exit For
            End If
        Next emp2
        MessageBox.Show("Mnaager: " & a_manager.Name)

        ' Doesn't work.
        For Each emp2 As Employee In people
            MessageBox.Show(emp2.Name)
        Next emp2
    End Sub

    Public Sub Test2()
        Dim employees As New Collection
        employees.Add(New Employee("Alice Auxley"))
        employees.Add(New Manager("Bob Brentwood"))
        employees.Add(New Manager("Cindy Crenshaw"))
        employees.Add(New Employee("Dirk Dunn"))
        ShowEmployees(employees)

        ' Works.
        Dim emp As Employee
        For i As Integer = employees.Count To 1 Step -1
            emp = CType(employees(i), Employee)
            If emp.IsManager Then employees.Remove(i)
        Next i
        ShowEmployees(employees)

        employees.Clear()
        employees.Add(New Employee("Alice Auxley"))
        employees.Add(New Manager("Bob Brentwood"))
        employees.Add(New Manager("Cindy Crenshaw"))
        employees.Add(New Employee("Dirk Dunn"))

        ' Doesn't work.
        For i As Integer = 1 To employees.Count
            emp = CType(employees(i), Employee)
            If emp.IsManager Then employees.Remove(i)
        Next i

        ShowEmployees(employees)
    End Sub

    Private Sub ShowEmployees(ByVal employees As Collection)
        Dim txt As String = ""
        For Each emp As Employee In employees
            txt &= emp.Name & vbCrLf
        Next emp
        MessageBox.Show(txt)
    End Sub

    Private Sub Test3()
        Dim txt As String = ""
        Dim m_Employees As New Collection
        m_Employees.Add(New Employee("Alice Auxley"))
        m_Employees.Add(New Manager("Bob Brentwood"))
        m_Employees.Add(New Manager("Cindy Crenshaw"))
        m_Employees.Add(New Employee("Dirk Dunn"))

        Dim emp As Employee
        Dim employee_enumerator As IEnumerator
        employee_enumerator = m_Employees.GetEnumerator()
        Do While (employee_enumerator.MoveNext)
            emp = CType(employee_enumerator.Current, Employee)
            txt &= emp.Name & vbCrLf
        Loop

        MessageBox.Show(txt)
    End Sub

End Class

Public Class Employee
    Public Name As String

    Public Sub New(ByVal new_name As String)
        Name = new_name
    End Sub

    Public Overridable Function IsManager() As Boolean
        Return False
    End Function
End Class
Public Class Customer
    Public Name As String

    Public Sub New(ByVal new_name As String)
        Name = new_name
    End Sub
End Class
Public Class Manager
    Inherits Employee

    Public Sub New(ByVal new_name As String)
        MyBase.new(new_name)
    End Sub
    Public Overrides Function IsManager() As Boolean
        Return True
    End Function
End Class